{-------------------------------------------}
{ gsxconst.pas - Pascal GSX Bibliothek:     }
{       Konstanten-Definitionen             }
{-------------------------------------------}

{ GSX-Geraete:
  Nummer  1-10: Bildschirmtreiber,
         11-20: Plottertreiber,
         21-30: Durckertreiber,
         31-40: Metafiles,
         41-50: andere Geraete.             }
  Screen              = 01;
  Plotter             = 11;
  Printer             = 21;
  Metafile            = 31;

{ Linienarten: }
  Solid               = 1;     { ---------- }
  Dashed              = 2;     { -----      }
  Dotted              = 3;     { - - - - -  }
  DashDot             = 4;     { -----  -   }
  LongDash            = 5;     { --------   }
  DashDotDot          = 6;     { ----- - -  }

{ Markierungsarten: }
  Dot                 = 1;     { . }
  Plus                = 2;     { + }
  Star                = 3;     { * }
  CircleMark          = 4;     { o }
  Cross               = 5;     { x }

{ Fuellarten: (Styles) }
  Hollow              = 0; { nur Rahmen }
{ Solid               = 1; s. Linienarten }
  Pattern             = 2; { Halbton-Muster }
  Hatch               = 3; { Schraffur }

{ Schraffurarten: (Indices ) }
  Vertical            = 1;
  Horizontal          = 2;
  Plus45Deg           = 3;
  Minus45Deg          = 4;
  Crossed             = 5;
  DiaCrossed          = 6;

{ Farb-Tabelle: }
  Black               = 0;
  Red                 = 1;
  Green               = 2;
  Blue                = 3;
  Cyan                = 4;
  Yellow              = 5;
  Magenta             = 6;
  White               = 7;

{ Zeichensaetze, sind geraeteabhaengig.
  Numerierung von 1 bis ???:           }
  Standard            = 1;

{ Zeichen-Modi: }
  Replace             = 1;
  Transparent         = 2;
  Complement          = 3;
  Erase               = 4;

{ Cursor-Operationen: }
  Up                  = 4;
  Down                = 5;
  Right               = 6;
  Left                = 7;
  Home                = 8;
  EraToScreenEnd      = 9;
  EraToLineEnd        = 10;

{ Video-Attribute: }
  Reverse             = 13;
  Normal              = 14;

{ Kreissegmentarten: }
  Arc                 = 2;    { Kreisbogen }
  PieSlice            = 3;    { Torte }

{ Positionierungs-Geraete: }
  Keyboard            = 1;
  MouseJoystick       = 2;

{ Eingabe-Geraete: }
  InputLocator        = 1;
  InputValuator       = 2;
  InputChoice         = 3;
  InputString         = 4;

{ Eingabe-Modi: }
{ auf Bestaetigung der Eingabe warten: }
  Request             = 1;
{ Eingabe nur lesen und sofort weiter: }
  Sample              = 2;

{ Geraetearten : }
  OutOnly             = 0; { nur Ausgabe }
  InpOnly             = 1; { nur Eingabe }
  InpOut              = 2; { beides }
  SegStore            = 4; { Geraeteabh.
                             segm. Speicher }
  MetaOut             = 5; { GKS Metafile-
                             ausgabe.       }

{-------------------------------------------}
        { Ende von gsxconst.pas }
