(*****************************************************************************)
(*                         ---  DRAW.INC  ---                                *)
(*                                                                           *)
(*               Unterprogramm-Modul zum Zeichnen der Funktion               *)
(*                                                                           *)
(*****************************************************************************)


   (* Hier beginnt der hardwareabhaengige Teil. Die Konstanten und Pro-
      zeduren sind entsprechend zu aendern. Hier Implementation unter GSX.
      Entsprechend sind im Hauptprogramm die Includes der GSX-Dateien ein-
      zusetzen.                                                               *)

   Const ScreenXMax = MaxInt; (* Anzahl Bildpunkte horizontal                 *)
         ScreenYMax = MaxInt; (*                   vertikal                   *)
         ScreenLeft = 500;    (* Abstand Zeichenflaeche-linker Bildschirmrand *)
         ScreenBott = 500;    (*                       -unterer               *)
         Unit       = 200;    (* halbe Breite der Achsenunterteilungsstriche  *)


   Procedure InitGraphic;     (* Voreinstellungen fuer Grafikbetrieb *)

      Begin
        Open_Workstation(Screen);
        IF VDI_Error THEN Halt;
        Enter_Graphics;
      End;


   Procedure LeaveGraphic;    (* Voreinstellungen fuer Textbetrieb *)

      Begin
        Close_Workstation;
      End;


   Procedure Plot (x,y :Integer);    (* Punkt bei (x,y) zeichnen *)

       Begin
         ptsin[1] := x;  ptsin[2] := y;  ptsin[3] := x; ptsin[4] := y;
         Poly_Line(2, ptsin);
       End;


   Procedure Draw (x1,y1,x2,y2 :Integer);(* Linie von (x1,y1) nach (x2,y2) *)

      Begin
         ptsin[1] := x1;  ptsin[2] := y1;  ptsin[3] := x2;  ptsin[4] := y2;
         Poly_Line(2, ptsin);
      End;

   (* hier endet der hardwareabhaengige Teil *)


   Procedure WorldToScreen (x,y :Real; Var xs,ys :Integer);

      Begin
        xs := round((x - xmin)*
              (ScreenXMax-ScreenLeft)/(xmax-xmin)) + ScreenLeft;
        ys := round((y - ymin)*
              (ScreenYMax-ScreenBott)/(ymax-ymin)) + ScreenBott;
      End;


   Procedure DrawPoint (x,y :Real);   (* zeichnet Punkt in Weltkoordinaten *)

      Var xp,yp :Integer;

      Begin
        WorldToScreen (x,y,xp,yp);
        Plot (xp,yp)
      End;


   Procedure DrawLine (x1,y1,x2,y2 :Real);           (* zeichnet Linie
                                                        in Weltkoordinaten *)

      Var xp1,yp1,xp2,yp2 :Integer;

      Begin
        WorldToScreen (x1,y1,xp1,yp1);
        WorldToScreen (x2,y2,xp2,yp2);
        Draw (xp1,yp1,xp2,yp2)
      End;

