(*****************************************************************************)
(*                                                                           *)
(*                            ---  FLEX.INC  ---                             *)
(*                                                                           *)
(*               Unterprogramm-Modul zur Wendestellenberechnung              *)
(*                                                                           *)
(*****************************************************************************)


Procedure FindFlexPoints;


   Var x,dx,
       xmin,xmax :Real;
       found,
       Success   :Boolean;

   Begin
   ClrScr;
   WriteLn ('Wendestellenbestimmung'); WriteLn;
   Write ('im Bereich von xmin='); Read (xmin);
   Write (' bis xmax='); Read (xmax);
   Write (' mit Schrittweite dx='); ReadLn (dx);
   WriteLn; WriteLn;
   found := false;
   x := Solve (xmin,xmax,dx,2,Success);
   If Success then
      Repeat
         If fn(x-dx,2) * fn(x+dx,2) < 0 then
            If (fn(x,1) < eps) and (fn(x,1) > -eps) then
               Write ('W')
            else
               Write ('S');
         WriteLn (' (',x:m:n,', ',fn(x,0):m:n,')');
         found := true;
         xmin := x + dx;
         x := Solve (xmin,xmax,dx,2,Success)
      until not Success or (x>xmax);
   If not found then WriteLn ('Keine Wendestelle gefunden!')
   End;
