(*-------------------------------------------------------------------------*)
(*                              GPLOTGDP.PAS                               *)
(* Zeichenprimitive (Generalized Drawing Primitives) fuer den Plottersimu- *)
(* lator. Fuer 'line' ist z.B. der Integer-DDA des Artikels 'Vom Punkt zur *)
(* dritten Dimension', Pascal 4/87, zu verwenden. Entsprechendes gilt fuer *)
(* 'circle' (einen der drei Algorithmen). Diese sind per 'Include' nach    *)
(* GPLOTSYS.PAS und vor GPLOTGDP.PAS einzubinden! (s. GPLOT.PAS)           *)
(*-------------------------------------------------------------------------*)

(*-------------------------------------------------------------------------*)
(*                          Linie zeichnen:                                *)

PROCEDURE Line (x1, y1, x2, y2: INTEGER);

BEGIN
  do_line(x1, y1, x2, y2);
END;

(*-------------------------------------------------------------------------*)
(*                          Rechteck zeichnen:                             *)
(* (x1,y1) = linke obere Ecke, (x2, y2) = rechte, untere Ecke              *)

PROCEDURE box (x1, y1, x2, y2: INTEGER);

BEGIN
  do_line(x1, y1, x2, y1);
  do_line(x1, y1, x1, y2);
  do_line(x2, y1, x2, y2);
  do_line(x1, y2, x2, y2);
END;

(*-------------------------------------------------------------------------*)
(*                           Kreis:                                        *)

PROCEDURE circle (x, y, r: INTEGER);

BEGIN
  do_circle(x, y, r);
END;

(*-------------------------------------------------------------------------*)
(*                     Ende von GPLOTGDP.PAS                               *)
