(*------------------------------------------------------------*)
(*                     GRAFCONS.PAS                           *)
(* Globale, systemspezifische Konstanten fuer die Grafikserie *)
(*------------------------------------------------------------*)

(*---------------------- Systemkonstanten: -------------------*)

(*  Die hier definierten Systemkonstanten gelten fuer einen
    MS-DOS Rechner mit der "normalen" Color-Grafikkarte CGA   *)

(* Grenzkoordinaten des verwendeten Systems:
   die damit definierten Typen verhindern illegale Koordinaten
   in der Prozedur 'Point_System', was sonst je nach System
   zu unangenehmen Abstuerzen fuehren kann. So wird nur das
   Pascal-Programm mit einer Fehlermeldung des Laufzeitsystems
   abgebrochen!                                               *)
  ScreenXmin_Sys = 0;
  ScreenXmax_Sys = 639;
  ScreenYmin_Sys = 0;
  ScreenYmax_Sys = 199;

(* Faktor zur Korrektur des Hoehen:Breiten-Verhaeltnisses:    *)
  Aspect_Ratio  = 0.5;

(* Ursprung des Koordinatensystems des verwendeten Systems:
     TRUE: linke, obere Ecke   FALSE: linke, untere Ecke      *)
  Origin_is_Top = TRUE;

(* Bereichsgrenzen zulaessiger Farbwerte:                     *)
  First_Color_Value = 0;
  Last_Color_Value  = 15;

(*------------------- Grafik-Systemkonstanten: ---------------*)

(* max. Grenzkoordinaten fuer unsere Grafik-Prozeduren, die
   mit Koordinaten von (0,0) bis (ScreenXmax,ScreenYmax) ar-
   beiten (s. Typen 'x_Koord' und 'y_Koord'):
     Bsp.: ScreenXmin_Sys = 1  und  ScreenXmax_Sys = 640
           --> ScreenXmax = 639 !
   Aehnlicher Zweck wie die Grenzkoordinaten des verwendeten
   Systems: zum Auffinden von illegalen Koordinaten inner-
   halb unseres Grafiksystems.                                *)

  ScreenXmax = 639;
  ScreenYmax = 199;

(*------------------------------------------------------------*)
(*                 Ende von GRAFCONS.PAS                      *)
