(*------------------------------------------------------------*)
(*                      GRAFTYPE.PAS                          *)
(*       Globale Typendefinition fuer die Grafikserie         *)
(*------------------------------------------------------------*)

  x_Koord_Sys = ScreenXmin_Sys..ScreenXmax_Sys;
  y_Koord_Sys = ScreenYmin_Sys..ScreenYmax_Sys;

  x_Koord = 0..ScreenXmax;
  y_Koord = 0..ScreenYmax;

  Sys_Colors = First_Color_Value..Last_Color_Value;

(*---------------------- Polygon-Typ: ------------------------*)

  PolyPunkt = RECORD       (* Punkt-Koordinaten eines Punktes *)
                x, y: INTEGER;
              END;
  PolyIndex = 1..PolyMax;      (* Indextyp fuer 'Range-Check' *)
  Polygon   = ARRAY [PolyIndex] OF PolyPunkt;

(*---------------------- Pattern-Typ: ------------------------*)

  PatternIndex = 0..PatternSize;
  Pattern_     = ARRAY [PatternIndex, PatternIndex] OF BOOLEAN;
  (* der Unterstrich hinter Pattern ist bei Turbo wg. einer
     Prozedur gleichen Namens notwendig!                      *)

(*--------------------------------------------------------------------------*)
(*                             GRAFTYPE.ERW                                 *)
(*  Erweiterung der Typendeklarationen der Graphikserie fuer Windowhandling *)

  (*-------------------------------------------------------------------*)
  (* Der folgende Typ WinBackground muss so vereinbart werden, dass er *)
  (* ggf. dazu geeignet ist, den Hintergrund, der beim oeffnen des     *)
  (* Fensters abgespeichert wird, aufzunehmen.                         *)
  (* SYSTEMABHAENGIG (wenn ueberhaupt moeglich) !                      *)

    WinBuffer = array[1..8003] of integer; (* Turbo Pascal auf MS-DOS *)
    WinBackground = ^WinBuffer;            (* mit CGA-Grafikkarte.    *)

  (*                                                                   *)
  (*-------------------------------------------------------------------*)

  WinNrBereich = NULL..MaxWins;

  WinRec = record
             xmin, ymin,
             xmax, ymax : real;            (* Weltkoordinatenausschnitt *)
             Pixel_pro_x,                  (* Window/Viewport- *)
             Pixel_pro_y : real;           (* Proportionen     *)
             Vxmin, Vxmax : x_Koord;       (* Bildschirmausschnitt *)
             Vymin, Vymax : y_Koord;       (* des Viewport         *)
             Background : WinBackground
           end;

  WinFeld = array[WinNrBereich] of ^WinRec;

(*-------------------------------------------------------------------------*)
(*                          Ende GRAFTYPE.ERW                              *)

(*------------------------------------------------------------*)
(*                     GRAFTYPE.ERW                           *)
(* Typendefinition fuer zweidimensionale Transformationen:    *)

 tVektor = array[1..xMatDim] of real;
 tMatrix = array[1..yMatDim,1..xMatDim] of real;

 ObjektIndex  = 1..MaxLineObj;
 LinienObjekt = array[ObjektIndex] of
                  Record
                    Vektor1, Vektor2: tVektor;
                  end;

(*------------------------------------------------------------*)
(*                   Ende GRAFTYPE.ERW                        *)

(*------------------------------------------------------------*)
(*                  Ende von GRAFTYPE.PAS                     *)