(*-------------------------------------------------------------------------*)
(*                             LINEOBJ.PAS                                 *)
(*    Transformieren und Darstellen von graphischen Objekten in Window-    *)
(*            Koordinaten, die sich nur aus Linien zusammensetzen.         *)
(*-------------------------------------------------------------------------*)
(*                  Transformieren eines LinienObjekts:                    *)

PROCEDURE TransformLinienObjekt (TransMat  : tMatrix;
                                 VAR Objekt: LinienObjekt;
                                 n         : INTEGER);

VAR i: ObjektIndex;

BEGIN
  FOR i := 1 TO n DO
    WITH Objekt[i] DO BEGIN
      Vektor1[3] := 1;                               (* Vektoren erweitern *)
      Vektor2[3] := 1;
      VektorTrans(Vektor1, TransMat);
      VektorTrans(Vektor2, TransMat);
    END
END;

(*-------------------------------------------------------------------------*)

PROCEDURE ZeigeLinienObjekt (TransMat  : tMatrix;
                             VAR Objekt: LinienObjekt;
                             n         : INTEGER);

VAR i: INTEGER;

BEGIN
  TransformLinienObjekt(TransMat, Objekt, n);
  FOR i := 1 TO n DO
    WITH Objekt[i] DO
      ClipLine(Vektor1[1], Vektor1[2], Vektor2[1], Vektor2[2])
END;

(*-------------------------------------------------------------------------*)

PROCEDURE LoescheLinienObjekt (Objekt: LinienObjekt; n: INTEGER);

VAR i: INTEGER;

BEGIN
  Set_Pen_Color(0);       (* Objekt einfach mit Hintergrundfarbe zeichnen! *)
  FOR i := 1 TO n DO
    WITH Objekt[i] DO
      ClipLine(Vektor1[1], Vektor1[2], Vektor2[1], Vektor2[2]);
  Set_Pen_Color(15)
END;

(*-------------------------------------------------------------------------*)
(*                            Ende LINEOBJ.PAS                             *)
