(*-------------------------------------------------------------------------*)
(*                             CELLMANI.PAS                                *)
(* Routinen zur Zeichenzellenmanipulation fuer die Zeichenausgaberoutinen  *)
(* der Grafikserie.                                                        *)
(*-------------------------------------------------------------------------*)
PROCEDURE MakeBold (VAR Cell : TCell);                      (* Fettschrift *)

VAR Temp : TCell;  i : TCellElemIndex;

BEGIN
  Temp := Cell;
  FOR i := 0 TO CellSize DO
    BEGIN  BitShift(Temp[i],1);  OrRow(Cell[i],Temp[i])  END
END;
(*-------------------------------------------------------------------------*)
PROCEDURE MakeSmall (VAR Cell : TCell);                   (* Schmalschrift *)

VAR Temp : TCell;  i : TCellElemIndex;

BEGIN
  Temp := Cell;
  FOR i := 0 TO CellSize DO
    BEGIN  BitShift(Temp[i],1);  AndRow(Cell[i],Temp[i])  END
END;
(*-------------------------------------------------------------------------*)
PROCEDURE MakeKursiv (VAR Cell : TCell);                (* Kursive Schrift *)

VAR i : TCellElemIndex;  Shift : INTEGER;

BEGIN
  FOR i := 0 TO CellSize DO       (* Reihen zwischen -2 u. 2 Pixel shiften *)
    BEGIN
      Shift :=  Round(4.0*(i-CellSize/2)/CellSize);  BitShift(Cell[i],Shift)
    END
END;
(*-------------------------------------------------------------------------*)
PROCEDURE MakeDoubleWide (VAR Cell, Cell2 : TCell); (* Dop. breite Schrift *)

VAR  i, Zeile : TCellElemIndex;

BEGIN
  FOR Zeile := 0 TO CellSize DO
    FOR i := CellSize DOWNTO 0 DO
      BEGIN
        IF i > CellSize DIV 2 THEN
          BEGIN
            Cell2[Zeile,2*i-7] := Cell[Zeile,i];
            Cell2[Zeile,2*i-8] := Cell[Zeile,i]
          END
        ELSE
          BEGIN
            Cell[Zeile,2*i+1] := Cell[Zeile,i];
            Cell[Zeile,2*i] := Cell[Zeile,i]
          END
      END
END;
(*-------------------------------------------------------------------------*)
PROCEDURE MakeDoubleHigh (VAR Cell, Cell2 : TCell);   (* Dop. hohe Schrift *)

VAR  i, Zeile : TCellElemIndex;   Temp : BOOLEAN;

BEGIN
  FOR i := CellSize DOWNTO 0 DO
    BEGIN
      IF i > CellSize DIV 2 THEN
        BEGIN  Cell2[2*i-7] := Cell[i];  Cell2[2*i-8] := Cell[i]  END
      ELSE
        BEGIN  Cell[2*i+1] := Cell[i];   Cell[2*i] := Cell[i]  END
    END
END;
(*-------------------------------------------------------------------------*)
(*                         Ende von CELLMANI.PAS                           *)
