(* ----------------------------------------------------------------------- *)
(*                              PDVAR.PAS                                  *)
(*                  System- und PULLDOWN-Variablen                         *)

(* Bildschirm und Bildschirm-Puffer: *)
      SaveRAM   :ARRAY [1..ScreenLen] OF BYTE;
      ScreenRAM :ARRAY [1..ScreenLen] OF BYTE ABSOLUTE ScreenSeg:ScreenOfs;

(* Vereinbarung der vom Pull-Down-Demo verwendeten Menus. Hier als typi-   *)
(* sierte Konstanten (TURBO-PASCAL!!), was Variablen mit einem definierten *)
(* Anfangswert entspricht. In anderen Dialekten muessen die hier aufge-    *)
(* fuehrten Groessen als VARiablen vereinbart und explizit initialisiert   *)
(* werden (Zuweisungen!). Siehe auch Begleitartikel!                       *)

CONST NoMenus = 7;                                     (* 7 Menues im Demo *)

      fcol    = white;                                      (* Rahmenfarbe *)
      ntcol   = black;                                    (* normaler Text *)
      nbcol   = lightgray;                         (* normaler Hintergrund *)
      stcol   = white;                                (* selektierter Text *)
      sbcol   = black;                         (* selektierter Hintergrund *)

      (* Die Bildschirm-Anfangspositionen der Menues: *)

      xpos :ARRAY [1..NoMenus] OF INTEGER = (1,1,15,27,40,53,66);
      ypos :ARRAY [1..NoMenus] OF INTEGER = (1,2,2,2,2,2,2);

(* ----------------------------------------------------------------------- *)

   Menu :ARRAY [1..NoMenus] OF MenuType =
 (* Main Menu: *)
    ((Item: ('    File     ','   Action    ','    Disk     ',
             '   Tools     ','    Exit     ','  Controls     ');
      NoItems: 6; LastItem: 1;
      FrameColor: lightgray;
      NormalText: lightgray; NormalBack: black;
      SelectText: black;     SelectBack: lightgray;
      vertical  : FALSE;     Frame     : FALSE),
 (* File Menu: *)
     (Item: (' Work File  ',' Main File  ',' SaveQuit   ',
             ' SaveCont   ',' QuitNoSave ','');
      NoItems: 5; LastItem: 1;
      FrameColor: fcol;
      NormalText: ntcol; NormalBack : nbcol;
      SelectText: stcol; SelectBack : sbcol;
      vertical  : TRUE;  Frame      : TRUE),
 (* Action Menu: *)
     (Item: (' Edit    ',' Compile ',' Link    ',' Run     ','','');
      NoItems: 4; LastItem: 1;
      FrameColor: fcol;
      NormalText: ntcol; NormalBack : nbcol;
      SelectText: stcol; SelectBack : sbcol;
      vertical  : TRUE;  Frame      : TRUE),
 (* Disk Menu: *)
     (Item: (' Directory    ',' Logged Drive ',' Set Paths    ','','','');
      NoItems: 3; LastItem: 1;
      FrameColor: fcol;
      NormalText: ntcol; NormalBack : nbcol;
      SelectText: stcol; SelectBack : sbcol;
      vertical  : TRUE;  Frame      : TRUE),
 (* Tools Menu: *)
     (Item: (' Execute     ',' Calculator  ',' Clock       ',
             ' ASCII-Table ',' Help        ','');
      NoItems: 5; LastItem: 1;
      FrameColor: fcol;
      NormalText: ntcol; NormalBack : nbcol;
      SelectText: stcol; SelectBack : sbcol;
      vertical  : TRUE;  Frame      : TRUE),
 (* Exit Menu: *)
     (Item: ('  ExitToDOS ','  Continue  ','','','','');
      NoItems: 2; LastItem: 1;
      FrameColor: fcol;
      NormalText: ntcol; NormalBack : nbcol;
      SelectText: stcol; SelectBack : sbcol;
      vertical  : TRUE;  Frame      : TRUE),
 (* Controls Menu: *)
     (Item: (' Sound      ',' WindowSize ',' AutoSave   ',
             ' LinkerOpt  ','','');
      NoItems: 4; LastItem: 1;
      FrameColor: fcol;
      NormalText: ntcol; NormalBack : nbcol;
      SelectText: stcol; SelectBack : sbcol;
      vertical  : TRUE;  Frame      : TRUE));
(* ----------------------------------------------------------------------- *)
(*                        Ende von PDVAR.PAS                               *)
