(* ----------------------------------------------------------------------- *)
(*                             CALLINT.INC                                 *)
(* Code, um aus einer von BEGININT.INC eingeleiteten TURBO-Interrupt-
   Routine in die urspruengliche Interrupt-Routine zu  gelangen. Nach Ab-
   schluss dieser gelangt man in die rufende Routine zurueck.
   Die Adresse der aufzurufenden, urspruenglichen Routine wird nach der
   Include-Anweisung angegeben.
   CALLINT.INC darf nur unmittelbar in der TURBO-Interrupt-Routine aufgeru-
   fen werden.
   Als naechstes muss der unter CALLINTE.INC zu findende INLINE-Befehl aus-
   gefuehrt werden.
   Die Adresse der aufzurufenden Routine muss vom Typ IntEntry_ sein.
   Sie muss als Konstante deklariert sein.  !!!
   Sie kann durch IntGet ermittelt werden .                                *)

   INLINE (
     $FA/            {       CLI              ; Routine wird ununterbrechbar}
     $1F/            {       POP DS           ; Registerinhalte             }
     $07/            {       POP ES           ;   wiederherstellen          }
     $5E/            {       POP SI           ;         .                   }
     $5F/            {       POP DI           ;         .                   }
     $5A/            {       POP DX           ;         .                   }
     $59/            {       POP CX           ;         .                   }
     $5B/            {       POP BX           ;         .                   }
     $58/            {       POP AX           ;         .                   }
     $9C/            {       PUSHF            ; PushFlags                   }
     $2E/$FF/$1E/    {       CALL CS: ...     ; Aufruf der alten Routine    }
(* ----------------------------------------------------------------------- *)
(*                          Ende CALLINT.INC                               *)
