(* ----------------------------------------------------------------------- *)
(*                               STATIS.PAS                                *)
(*                           Statistik in Pascal                           *)
PROGRAM statistic (Input, Output);

CONST Zeilen  = 30;     { willkuerliche Grenze fuer Vectoren und Matrizen   }
      Spalten = 10;     { willkuerliche Grenze fuer array of Vector         }
      MaxMat  = 30;     { willkuerliche Grenze fuer quadratische (!) Matrix }
      MaxReal = +0.1E38;
      MinReal = -0.1E38;
      escape  = 27;                           (* ASCII-Code fuer ESC-Taste *)

TYPE  filename        = STRING[32];
      Parametervector = ARRAY[1..3] OF REAL;
      Verteilungstyp  = (ber,bin,hyp,poi,expo,gch,nor,sta,stu,chi,fis);
      vector          = RECORD
                          value, gew : ARRAY[1..Zeilen] OF REAL;
                          n          : INTEGER;             { Zeilen - Rang }
                        END;
      matrix          = RECORD
                          ele        : ARRAY[1..MaxMat,1..MaxMat] OF REAL;
                          s,z        : INTEGER;     { Spalten/Zeilen - Rang }
                        END;
      DatenMatrix     = RECORD
                          zeile      : ARRAY[1..Spalten] OF vector;
                          s,z        : INTEGER;
                        END;

VAR   ch              : CHAR;            { globale Lesevaribale (KBD) }
      ende            : BOOLEAN;         { Variable fuer Endlosschleife }

{$I IO.inc }
{$I lage.inc }
{$I util.inc }
{$I dichte.inc }
{$I verteil.inc }
{$I quantile.inc }
{$I test.inc }
{$I correl.inc }

BEGIN
  ENDE := FALSE;
  REPEAT
    ClrScr;
    WriteLn('PASCAL-INTERNATIONAL: STATISTIK         ':55);
    WriteLn('===============================         ':55);
    WriteLn;
    WriteLn('< 1 > Deskriptive Statistik              ':55);
    WriteLn('< 2 > Konfidenzintervall fuer Mittelwert ':55);
    WriteLn('< 3 > Konfidenzintervall fuer Varianz    ':55);
    WriteLn('< 4 > Konfidenzintervall fuer Korrelation':55);
    WriteLn('< 5 > Hypothesentest auf Mittelwert      ':55);
    WriteLn('< 6 > Hypothesentest auf Varianz         ':55);
    WriteLn('< 7 > Hypothesentest auf Korrelation     ':55);
    WriteLn('< 8 > partielle Korrelation              ':55);
    WriteLn('< 9 > bipartielle Korrelation            ':55);
    WriteLn('<ESC> Programmende                       ':55);
    Writeln; writeln; writeln; Write('Bitte waehlen Sie...':21);
                        (* Zeichen ohne Bildschirmecho von Tastatur lesen: *)
    repeat Read(Kbd, Ch); until (ch in ['1'..'9']) or (ord(ch) = escape);
    ClrScr;                                         (* Bildschirm loeschen *)
    CASE Ch OF
       '1' :  descript;
       '2' :  mitkonfidenz;
       '3' :  varianzkonfidenz;
       '4' :  corrkonfidenz;
       '5' :  mitteltest;
       '6' :  varianztest;
       '7' :  corrtest;
       '8' :  part_corr;
       '9' :  bicorr;
      Else ende := true;
    END;
  UNTIL ENDE;
END.
