
(*------------------------------------------------------------*)
(*                        BLICKMAT.PAS                        *)
(*                Konstruktion der Blickmatrix                *)

(*------------------------------------------------------------*)
(*           Aufbau des U-V-NV-Koordinatensystems             *)
PROCEDURE UVNV(VAR NV, SV, U, V : tVektor);

VAR a : REAL;
    i : INTEGER;
    temp : tVektor;

BEGIN
  NormalVek(NV);
  (*-- SV auf die PE projizieren --*)
  a := PunktProd(NV,SV);
  FOR i := 1 TO 3 DO
    temp[i] := a*NV[i];
  temp[4] := 1;  (* homogenisieren *)
  SubVek(SV,temp,V);
  KreuzProd(NV,V,U); (*-- U berechnen --*)
END;
(*------------------------------------------------------------*)
(*           Rotationsmatrix fuer 3D-Darstellung              *)
PROCEDURE RotMat(U, V, NV : tVektor; VAR Rot : tMatrix);

VAR i : INTEGER;

BEGIN
  EinheitsMatrix(Rot);
  FOR i := 1 TO 3 DO BEGIN
    Rot[i,1] := U[i];  Rot[i,2] := V[i];  Rot[i,3] := NV[i];
  END;
END;
(*------------------------------------------------------------*)
(*                     Ende BLICKMAT.PAS                      *)
